<template lang="pug">
.page-cont
  .page-header(v-observe-visibility="visibilityChanged")
    .page-header__img(v-if="hero_image")
      .page-header__img-line
      img(:src="hero_image" alt="")
    .container
      .page-header__go-back(v-if="hasPrevPage")
        span(
          @click="$router.back()"
        ) {{ $t('forms.buttons.back') }}
      h1.page-header__title(v-if="hero_title || title")
        div(v-html="hero_title || title")

  .services-items-wrap
    .container
      .services-items
        .services-item(
          v-for="service in services"
          :key="service.id"
        )
          nuxt-link.service-preview(
            :to="{ name: 'services-slug', params: { locale, slug: service.slug } } | url"
          )
            .service-preview__hover
              span {{ $t('moreDetails') }}

            .service-preview__text
              div
                .service-preview__title(v-if="service.title") {{ service.title }}
                .service-preview__descr(v-if="service.list_description") {{ service.list_description }}

              .service-preview__logo
                img(:src="`/images/logo2-${theme}.svg`" alt="")

            .service-preview__image(v-if="service.list_image")
              img(:src="service.list_image" alt="")

      pagination(
        v-if="totalPageCount > 1"
        :value="pageIndex"
        active-class="is-active"
        :click-handler="selectPage"
        :hide-prev-next="true"
        :margin-pages="1"
        :query="$route.query"
        :page-count="totalPageCount"
        :page-range="3"
      )
</template>

<script>
import { visibilityMixin } from '@/mixins/visibility'
import { pageMixin } from '@/mixins/pages'
import { hasPrevPageMixin } from '@/mixins/has-prev-page'
import { fetchPage } from '@/utils/asyncPages'
import API from '../../api'
import { mapState } from 'vuex'
import { url } from '@/filters'
import isEqual from 'lodash/isEqual'
import config from '@/config'

const PER_PAGE = 10

export const updateParamsFromQuery = (query, obj) => {
  const page = parseInt(query.page)
  obj.pageIndex = isNaN(page) ? 1 : page
  return obj
}

export async function fetchServices (app, options) {
  const params = { limit: PER_PAGE, offset: 0 }

  if (options.page) {
    params.offset = (options.page - 1) * PER_PAGE
  }

  const response = await app.$axios.get(API.services.services(), { params })

  return {
    services: response.data.results,
    totalPageCount: Math.ceil(response.data.count / PER_PAGE)
  }
}

export default {
  name: 'ServicesPage',

  async asyncData ({ app, error, query }) {
    let result = updateParamsFromQuery(query, {})
    const options = { page: result.pageIndex }

    try {
      const [page, servicesResult] = await Promise.all([
        fetchPage(app, error, API.services.servicesPage()),
        fetchServices(app, options)
      ])

      result = Object.assign({}, result, servicesResult, page)
    } catch (e) {
      if (process.browser) {
        console.log(e)
        return error()
      }
    }

    return result
  },

  beforeRouteUpdate (to, from, next) {
    updateParamsFromQuery(to.query, this.$store, this)

    if (process.browser) {
      window.scrollTo(0, 0)
    }
    return next()
  },

  computed: {
    ...mapState({
      locale: state => state.locale
    }),

    theme () {
      return config.theme
    }
  },

  data () {
    return {
      pageIndex: 1,
      totalPageCount: 0
    }
  },

  filters: { url },
  layout: 'white-header',

  methods: {
    async fetchData () {
      const res = await fetchServices(this, { page: this.pageIndex })
      this.services = res.services
      this.totalPageCount = res.totalPageCount
    },

    selectPage (page) {
      this.pageIndex = page
    },

    updateURL () {
      const query = {}
      if (this.pageIndex && this.pageIndex > 1) {
        query.page = this.pageIndex
      }

      if (!isEqual(query, this.$route.query)) {
        this.$router.replace({ query })
      }
    }
  },

  mixins: [hasPrevPageMixin, pageMixin, visibilityMixin],

  watch: {
    pageIndex () {
      this.updateURL()
      this.fetchData()
    }
  }
}
</script>
